// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "MiniScan.h"

#include "MainFrm.h"
#include ".\mainfrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	//ON_BN_CLICKED(IDC_SCANDLG_CHECK, OnBnClickedScanDlgCheck)
	//ON_BN_CLICKED(IDC_FRONT_VIEW_CHECK, OnBnClickedFrontViewCheck)
	//ON_BN_CLICKED(IDC_BACK_VIEW_CHECK, OnBnClickedBackViewCheck)
	//ON_BN_CLICKED(IDC_FIT_CHECK, OnBnClickedFitCheck)
	//ON_BN_CLICKED(IDC_ONETOONE_CHECK, OnBnClickedOnetooneCheck)
	//ON_WM_HSCROLL()
	ON_COMMAND(ID_FILE_PREFEED, OnFilePrefeed)
	ON_UPDATE_COMMAND_UI(ID_FILE_PREFEED, OnUpdateFilePrefeed)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	//ID_INDICATOR_CAPS,
	//ID_INDICATOR_NUM,
	//ID_INDICATOR_SCRL,
};


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
	:m_prefeedEnabled(false)
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// Do not delete this view. MFC will delete it.
	// In the CView destructor it will delete itself.
	m_pWndView = new CChildView();


	// create a view to occupy the client area of the frame
	if (!m_pWndView->Create(NULL, NULL, AFX_WS_DEFAULT_VIEW,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}

	// Call this to set the active view so that when the ViewDialog class 
	// calls GetActiveView, it will get it and not a NULL ptr. MFC will call 
	// SetActiveView(), but only after the user click on the view area to make 
	// it active, which they might not do. So we explicitly set it active here.
	SetActiveView(m_pWndView);
	
#if 0
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
#endif

	if (!m_wndStatusBar.Create(this) 
		|| !m_wndStatusBar.SetIndicators(indicators, sizeof(indicators)/sizeof(UINT))
		)
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

#if 0
	// TODO: Delete these three lines if you don't want the toolbar to be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
#endif
#if 0
	if (!m_dialogBar.Create(this, IDD_VIEW_DIALOG,
		CBRS_TOP|CBRS_TOOLTIPS|CBRS_FLYBY, IDD_VIEW_DIALOG))
	{
		TRACE0("Failed to create DlgBar\n");
		return -1;      // fail to create
	}
#endif
	if (!m_viewDialog.Create(this, IDD_VIEW_DIALOG,
		CBRS_TOP|CBRS_TOOLTIPS|CBRS_FLYBY, IDD_VIEW_DIALOG))
	{
		TRACE0("Failed to create view dialog\n");
		return -1;      // fail to create
	}
	m_viewDialog.ShowWindow(SW_SHOW);

	if (!m_scanDialog.Create(this, IDD_SCAN_DIALOG,
		CBRS_LEFT|CBRS_TOOLTIPS|CBRS_FLYBY, IDD_SCAN_DIALOG))
	{
		TRACE0("Failed to create scan dialog\n");
		return -1;      // fail to create
	}

	m_scanDialog.EnablePrefeed(m_prefeedEnabled);
	m_scanDialog.ShowWindow(SW_SHOW);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame message handlers

void CMainFrame::OnSetFocus(CWnd* /*pOldWnd*/)
{
	// forward focus to the view window
	m_pWndView->SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// let the view have first crack at the command
	if (m_pWndView->OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

// Pass idle time processing along to the scan dialog which
// reads image data during idle time.
BOOL CMainFrame::OnIdle(LONG lCount)
{
	return m_scanDialog.OnIdle(lCount);
}

void CMainFrame::SetBitmapFilename(int side, CString filename)
{
	m_pWndView->SetBitmapFilename(side, filename);
}

void CMainFrame::ShowScanDialog(bool show)
{
	m_scanDialog.ShowWindow(show ? SW_SHOW : SW_HIDE);

	// Send a WM_SIZE message to force the window to redraw the dialog bars.
	// But don't actually change the size.
	CRect rect;
	GetWindowRect(rect);
	SendMessage(WM_SIZE, rect.Width(), rect.Height());
}

void CMainFrame::SetStatusText(string text)
{
	m_wndStatusBar.SetPaneText(0, text.c_str());


}


void CMainFrame::OnFilePrefeed()
{
	// Toggle the prefeed enable.
	m_prefeedEnabled = !m_prefeedEnabled;

	// Notify the scan dialog of the new prefeed enable state.
	m_scanDialog.EnablePrefeed(m_prefeedEnabled);
}

void CMainFrame::OnUpdateFilePrefeed(CCmdUI *pCmdUI)
{
	// Put a checkmark on the prefeed menu item if prefeed is enabled.
	pCmdUI->SetCheck(m_prefeedEnabled ? 1 : 0);
}
