
#include "stdafx.h"
#include "SIScanner.h"
#include <string>
using namespace std;




SIScanner::SIScanner()
	:m_hScannerDLL(NULL)
{
}


bool SIScanner::Attach(string DllPathname)
{

	m_hScannerDLL = LoadLibrary(DllPathname.c_str());

	if(m_hScannerDLL == NULL)
	{
		TRACE("Could not load DLL using pathname: &d", DllPathname.c_str());
		return false;
	}

	// DLL is loaded ok. Now link up all API functions. If any of them fail,
	// Then unload the DLL and return failure.
	bool link = true;

	if ((SI_GetScannerStatusDLL = (SI_GetScannerStatusProc) GetProcAddress( m_hScannerDLL, "SI_GetScannerStatus" )) == NULL)
	{	link = false;	}
	if ((SI_GetPaperStatusDLL = (SI_GetPaperStatusProc) GetProcAddress( m_hScannerDLL, "SI_GetPaperStatus" )) == NULL)
	{	link = false;	}
	if ((SI_GetButtonStatusDLL = (SI_GetButtonStatusProc) GetProcAddress( m_hScannerDLL, "SI_GetButtonStatus" )) == NULL)
	{	link = false;	}
	if ((SI_GetPropertyDLL = (SI_GetPropertyProc) GetProcAddress( m_hScannerDLL, "SI_GetProperty" )) == NULL)
	{	link = false;	}
	if ((SI_SetPropertyDLL = (SI_SetPropertyProc) GetProcAddress( m_hScannerDLL, "SI_SetProperty" )) == NULL)
	{	link = false;	}
	if ((SI_ResetDLL = (SI_ResetProc) GetProcAddress( m_hScannerDLL, "SI_Reset" )) == NULL)
	{	link = false;	}
	if ((SI_DiagnosticDLL = (SI_DiagnosticProc) GetProcAddress( m_hScannerDLL, "SI_Diagnostic" )) == NULL)
	{	link = false;	}
	if ((SI_GetLastErrorTextDLL = (SI_GetLastErrorTextProc) GetProcAddress( m_hScannerDLL, "SI_GetLastErrorText" )) == NULL)
	{	link = false;	}
	if ((SI_GetLastErrorDLL = (SI_GetLastErrorProc) GetProcAddress( m_hScannerDLL, "SI_GetLastError" )) == NULL)
	{	link = false;	}
	if ((SI_StartScanDLL = (SI_StartScanProc) GetProcAddress( m_hScannerDLL, "SI_StartScan" )) == NULL)
	{	link = false;	}
	if ((SI_ReadImageDataDLL = (SI_ReadImageDataProc) GetProcAddress( m_hScannerDLL, "SI_ReadImageData" )) == NULL)
	{	link = false;	}
	if ((SI_EndScanDLL = (SI_EndScanProc) GetProcAddress( m_hScannerDLL, "SI_EndScan" )) == NULL)
	{	link = false;	}
	if ((SI_OpenInterfaceDLL = (SI_OpenInterfaceProc) GetProcAddress( m_hScannerDLL, "SI_OpenInterface" )) == NULL)
	{	link = false;	}
	if ((SI_CloseInterfaceDLL = (SI_CloseInterfaceProc) GetProcAddress( m_hScannerDLL, "SI_CloseInterface" )) == NULL)
	{	link = false;	}
	if ((SI_GetEventDLL = (SI_GetEventProc) GetProcAddress( m_hScannerDLL, "SI_GetEvent" )) == NULL)
	{	link = false;	}
	if ((SI_CalibrateDLL = (SI_CalibrateProc) GetProcAddress( m_hScannerDLL, "SI_Calibrate" )) == NULL)
	{	link = false;	}
	if ((SI_IsCalibratedDLL = (SI_IsCalibratedProc) GetProcAddress( m_hScannerDLL, "SI_IsCalibrated" )) == NULL)
	{	link = false;	}
	if ((SI_FeedPaperOutDLL = (SI_FeedPaperOutProc) GetProcAddress( m_hScannerDLL, "SI_FeedPaperOut" )) == NULL)
	{	link = false;	}
	if ((SI_FeedDLL = (SI_FeedProc) GetProcAddress( m_hScannerDLL, "SI_Feed" )) == NULL)
	{	link = false;	}

	if(link == false)
	{
		TRACE("One or more DLL functions could not be linked.");
		FreeLibrary( m_hScannerDLL );
		m_hScannerDLL = NULL;
		return false;
	}

	return true;
}


void SIScanner::Detach()
{
	if(m_hScannerDLL)
	{
		FreeLibrary( m_hScannerDLL );
		m_hScannerDLL = NULL;
	}
}


SIResult SIScanner::SI_GetScannerStatus(SIScannerStatus *pScannerStatus)
{
	return SI_GetScannerStatusDLL(pScannerStatus);
}

SIResult SIScanner::SI_GetPaperStatus(SIPaperStatus *pPaperStatus)
{
	return SI_GetPaperStatusDLL(pPaperStatus);
}

SIResult SIScanner::SI_GetButtonStatus(uint32 buttonNumber, SIButtonStatus *pButtonStatus)
{
	return SI_GetButtonStatusDLL(buttonNumber, pButtonStatus);
}

SIResult SIScanner::SI_GetProperty(SIProperty* pProperty)
{
	return SI_GetPropertyDLL(pProperty);
}

SIResult SIScanner::SI_SetProperty(SIProperty* pProperty)
{
	return SI_SetPropertyDLL(pProperty);
}

SIResult SIScanner::SI_Reset()
{
	return SI_ResetDLL();
}

SIResult SIScanner::SI_Diagnostic(SIDiagTest test, void* pDiagInfo)
{
	return SI_DiagnosticDLL(test, pDiagInfo);
}

SIResult SIScanner::SI_GetLastError()
{
	return SI_GetLastErrorDLL();
}

SIResult SIScanner::SI_GetLastErrorText(char **ppErrorText)
{
	return SI_GetLastErrorTextDLL(ppErrorText);
}

SIResult SIScanner::SI_StartScan()
{
	return SI_StartScanDLL();
}

SIResult SIScanner::SI_ReadImageData(uint8 *buffer, uint32 numberOfLinesToRead, uint32 pageNumber, uint32* numberOfLinesReturned)
{
	return SI_ReadImageDataDLL(buffer, numberOfLinesToRead, pageNumber, numberOfLinesReturned);
}

SIResult SIScanner::SI_EndScan()
{
	return SI_EndScanDLL();
}

SIResult SIScanner::SI_OpenInterface(const char* pName)
{
	return SI_OpenInterfaceDLL(pName);
}

SIResult SIScanner::SI_CloseInterface()
{
	return SI_CloseInterfaceDLL();
}

SIResult SIScanner::SI_GetEvent(SIEventInfo* pEventInfo)
{
	return SI_GetEventDLL(pEventInfo);
}

SIResult SIScanner::SI_Calibrate(uint32 target, ProgressCallbackPtr pProgressCallback)
{
	return SI_CalibrateDLL(target, pProgressCallback);
}

SIResult SIScanner::SI_IsCalibrated()
{
	return SI_IsCalibratedDLL();
}

SIResult SIScanner::SI_FeedPaperOut()
{
	return SI_FeedPaperOutDLL();
}

SIResult SIScanner::SI_Feed()
{
	return SI_FeedDLL();
}





