// ViewDialog.cpp : implementation file
//

#include "stdafx.h"
#include "MiniScan.h"
#include "ViewDialog.h"
#include "MainFrm.h"
#include <cassert>
#include ".\viewdialog.h"


// ViewDialog dialog

IMPLEMENT_DYNAMIC(ViewDialog, DialogBarEx)
ViewDialog::ViewDialog(CWnd* pParent /*=NULL*/)
{
}

ViewDialog::~ViewDialog()
{
}

void ViewDialog::DoDataExchange(CDataExchange* pDX)
{
	DialogBarEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SCANDLG_CHECK, m_scanDialogCheck);
	DDX_Control(pDX, IDC_FRONT_VIEW_CHECK, m_frontViewCheck);
	DDX_Control(pDX, IDC_BACK_VIEW_CHECK, m_backViewCheck);
	DDX_Control(pDX, IDC_ZOOM_SLIDER, m_zoomSlider);
	DDX_Control(pDX, IDC_ZOOM_STATIC, m_zoomStatic);

}


BEGIN_MESSAGE_MAP(ViewDialog, DialogBarEx)
	ON_BN_CLICKED(IDC_SCANDLG_CHECK, OnBnClickedScanDlgCheck)
	ON_BN_CLICKED(IDC_FRONT_VIEW_CHECK, OnBnClickedFrontViewCheck)
	ON_BN_CLICKED(IDC_BACK_VIEW_CHECK, OnBnClickedBackViewCheck)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_FIT_BUTTON, OnBnClickedFitButton)
END_MESSAGE_MAP()


BOOL ViewDialog::OnInitDialogBar()
{
	DialogBarEx::OnInitDialogBar();

	m_scanDialogCheck.SetCheck(TRUE);
	m_frontViewCheck.SetCheck(TRUE);
	m_backViewCheck.SetCheck(FALSE);

	m_zoomSlider.SetRange(1, 8);
	m_zoomStatic.SetWindowText("");
	return TRUE;	// return TRUE unless you set the focus to a control
}

void ViewDialog::OnBnClickedScanDlgCheck()
{
	// TODO: Add your control notification handler code here
	bool show = (m_scanDialogCheck.GetCheck() == TRUE) ? true : false;

	((CMainFrame *)GetParent())->ShowScanDialog(show);

}

void ViewDialog::OnBnClickedFrontViewCheck()
{
	// Set the back button to opposite state of front button, so that
	// they act as radio buttons.
	int frontState = m_frontViewCheck.GetCheck();
	m_backViewCheck.SetCheck( frontState? FALSE : TRUE);

	CChildView* pView =  (CChildView*)(((CMainFrame *)GetParent())->GetActiveView());
	pView->SetCurrentView(frontState ? 0 : 1);
}

void ViewDialog::OnBnClickedBackViewCheck()
{
	// Set the front button to opposite state of backbutton, so that
	// they act as radio buttons.
	int backState = m_backViewCheck.GetCheck();
	m_frontViewCheck.SetCheck( backState? FALSE : TRUE);

	CChildView* pView =  (CChildView*)((CMainFrame *)GetParent())->GetActiveView();
	pView->SetCurrentView(backState ? 1 : 0);
}

void ViewDialog::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// TODO: Add your message handler code here and/or call default
	int pos = m_zoomSlider.GetPos();

	CChildView* pView =  (CChildView*)((CMainFrame *)GetParent())->GetActiveView();
	pView->SetZoom(pos);

	CString str;
	str.Format("%d:1", pos);
	m_zoomStatic.SetWindowText(str);

	DialogBarEx::OnHScroll(nSBCode, nPos, pScrollBar);
}


void ViewDialog::OnBnClickedFitButton()
{
	// TODO: Add your control notification handler code here
	CChildView* pView =  (CChildView*)((CMainFrame *)GetParent())->GetActiveView();

	// Set zero means to fit to window
	pView->SetZoom(0);
	m_zoomStatic.SetWindowText("");

}
