#pragma once

class BitmapFile
{
public:
	BitmapFile(void);
	virtual ~BitmapFile(void);


	bool Open(const char* filepath);
	void Close();

	bool SetWidth(int width);
	bool SetHeight(int height);
	bool SetBitsPerPixel(int bitsPerPixel);
	bool Write(const char * pBuffer, unsigned int lengthInBytes);
	bool Seek(int filePosition);
	inline bool IsOpen();

private:
	void DoFirstWrite();

private:
	bool	m_isOpen;
	bool	m_dirty;
	int		m_currentFileOffset;
	int		m_totalImageBytesWritten;
	bool	m_dataWritten;
	HANDLE	m_hFile;

	BITMAPFILEHEADER	m_bmFileHeader;
	BITMAPINFOHEADER	m_bmInfoHeader;
	RGBQUAD				m_colorTable[256];	// allocate enough for grayscale



};


inline bool BitmapFile::IsOpen()
{
	return m_isOpen;
}
