#pragma once
#include "afxwin.h"
#include "DialogBarEx.h"
#include "ScannerAPI.h"
#include "afxcmn.h"

// CalibrationDialog dialog

class CalibrationDialog : public DialogBarEx
{
	DECLARE_DYNAMIC(CalibrationDialog)

public:
	CalibrationDialog(CWnd* pParent = NULL);   // standard constructor
	virtual ~CalibrationDialog();

// Dialog Data
	enum { IDD = IDD_CALIBRATION };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedGetCalibrationStateButton();
	CStatic m_calibrationStateStatic;
	virtual BOOL OnInitDialogBar();
	afx_msg void OnBnClickedDoCalibrationButton();
	afx_msg void OnBnClickedCleanButton();
};


// CProgressDialog dialog

class CProgressDialog : public CDialog
{
	DECLARE_DYNAMIC(CProgressDialog)

public:
	enum Operation { OPER_CALIBRATE, OPER_CLEAN };

	CProgressDialog(Operation operation, CWnd* pParent = NULL);   // standard constructor
	CProgressDialog(CWnd* pParent = NULL);   // standard constructor
	virtual ~CProgressDialog();

// Dialog Data
	enum { IDD = IDD_PROG_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();

	static int32 SICALLBACK ProgressCallback(uint32 percentCompleted);
	static CProgressDialog* pToInstance;
	static bool	cancelOperation;

	CProgressCtrl m_progressControl;
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnBnClickedCancelOperation();
	CStatic m_progressStatic;
	Operation m_operation;
};
