// MainFrm.h : interface of the CMainFrame class
//


#pragma once

#include "ChildView.h"
#include "OpenCloseDialog.h"
#include "CalibrationDialog.h"
#include "StatusDialog.h"
#include "ScanParametersDialog.h"
#include "ScanActionsDialog.h"
#include "OtherDialog.h"

//#include "OpenCloseDialogBar.h"

class CMainFrame : public CFrameWnd
{
	
public:
	CMainFrame();
protected: 
	DECLARE_DYNAMIC(CMainFrame)

// Attributes
public:

// Operations
public:

// Overrides
public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;
	CChildView    *m_wndView;

	CDialogBar				m_dialogBar;
	OpenCloseDialog			m_openCloseDialog;
	CalibrationDialog		m_calibrationDialog;
	StatusDialog			m_statusDialog;
	ScanParametersDialog	m_scanParametersDialog;
	ScanActionsDialog		m_scanActionsDialog;
	OtherDialog				m_otherDialog;

	int m_currentlyActiveButtonID;
	DialogBarEx* m_pCurrentlyActiveDialog;

private:
	void UpdateDialogBars(int buttonID, DialogBarEx* pDialog);


// Generated message map functions
protected:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSetFocus(CWnd *pOldWnd);
	DECLARE_MESSAGE_MAP()
public:
	void InterfaceOpened();
	void SetBitmapFilename(int side, CString filename);
	BOOL OnIdle(LONG lCount);

protected:
	virtual void PostNcDestroy();
public:
	afx_msg void OnBnClickedFrontViewCheck();
	afx_msg void OnBnClickedBackViewCheck();
	afx_msg void OnBnClickedOpenCloseCheck();
	afx_msg void OnBnClickedCalibrationCheck();
	afx_msg void OnBnClickedOpenInterfaceButton();
	afx_msg void OnBnClickedStatusCheck();
	afx_msg void OnBnClickedScanParametersCheck();
	afx_msg void OnBnClickedScanActionsCheck();
	afx_msg void OnBnClickedOtherCheck();
	afx_msg void OnBnClickedZoomCheck();
	void EnableNonOpenCloseButtons(BOOL enable);
};



