#pragma once
#include "afxwin.h"
#include "ScannerAPI.h"
#include "DialogBarEx.h"

// ScanParametersDialog dialog

class ScanParametersDialog : public DialogBarEx
{
	DECLARE_DYNAMIC(ScanParametersDialog)

public:
	ScanParametersDialog(CWnd* pParent = NULL);   // standard constructor
	virtual ~ScanParametersDialog();

// Dialog Data
	enum { IDD = IDD_SCAN_PARAMETERS };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
private:

	bool ControlsToProperties();
	void ShowError(SIProperty &prop);
	char *PropertyIDToText(int propertyID);
	void BuildSampleLUT();
	bool m_suppressApplyButtonUpdate;	// Allows the ControlsToProperties method to supress
										// the updating of the Apply button text by the
										// OnCommand method.
	uint16	m_lut[256];		// used to build a lookup table that is downloaded to the scanner.

	// Controls
	CComboBox m_modeCombo;
	CComboBox m_resolutionCombo;
	CEdit m_leftOffsetEdit;
	CEdit m_topOffsetEdit;
	CEdit m_widthEdit;
	CEdit m_lengthEdit;
	CComboBox m_channelOrderCombo;
	CEdit m_brightnessEdit;
	CEdit m_contrastEdit;
	CEdit m_thresholdEdit;
	CEdit m_gammaEdit;
	CEdit m_highlightEdit;
	CEdit m_shadowEdit;
	CButton m_descreenCheckbox;
	CButton m_duplexCheckbox;
	CButton m_EOPDetectCheckbox;
	CButton m_spoolerCheckbox;
	CComboBox m_planarChunkyCombo;
	CComboBox m_photoInterpCombo;
	CComboBox m_feedDirectionCombo;
	CButton m_setScanRateCheckbox;
	CEdit m_scanRateEdit;
	CEdit m_feedRateEdit;
	CComboBox m_grayLUTCombo;
	CComboBox m_redLUTCombo;
	CComboBox m_greenLUTCombo;
	CComboBox m_blueLUTCombo;
	CStatic m_lineWidthInBytesStatic;
	CStatic m_bitsPerPixelStatic;
	CStatic m_maxScanTimeStatic;
	CStatic m_bitsPerChannelStatic;
	CStatic m_usbRateStatic;
public:
	virtual BOOL OnInitDialogBar();
	void PropertiesToControls();

	afx_msg void OnBnClickedReadCurrentButton();
	afx_msg void OnBnClickedApplyButton();
	afx_msg void OnResolutionComboSelectChanged();

protected:
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
};
