#include "stdafx.h"

#define IN_SCANNER_CPP
#include "Scanner.h"

Scanner g_scanner;

Scanner::Scanner()
	:m_hScannerDLL(NULL)
{
}

Scanner::~Scanner()
{
	Detach();
}

bool Scanner::Attach(char* DLLPathname)
{
	if(NULL == DLLPathname)
	{
		return false;
	}

	if(IsAttached())
	{
		Detach();
	}

	m_hScannerDLL = LoadLibrary(DLLPathname);

	if(m_hScannerDLL == NULL)
	{
		return false;
	}

	// DLL is loaded ok. Now link up all API functions. If any of them fail,
	// Then unload the DLL and return failure.
	bool link = true;

	if ((SI_GetScannerStatus = (SI_GetScannerStatusProc) GetProcAddress( m_hScannerDLL, "SI_GetScannerStatus" )) == NULL)
	{	link = false;	}
	if ((SI_GetPaperStatus = (SI_GetPaperStatusProc) GetProcAddress( m_hScannerDLL, "SI_GetPaperStatus" )) == NULL)
	{	link = false;	}
	if ((SI_GetButtonStatus = (SI_GetButtonStatusProc) GetProcAddress( m_hScannerDLL, "SI_GetButtonStatus" )) == NULL)
	{	link = false;	}
	if ((SI_GetProperty = (SI_GetPropertyProc) GetProcAddress( m_hScannerDLL, "SI_GetProperty" )) == NULL)
	{	link = false;	}
	if ((SI_SetProperty = (SI_SetPropertyProc) GetProcAddress( m_hScannerDLL, "SI_SetProperty" )) == NULL)
	{	link = false;	}
	if ((SI_Reset = (SI_ResetProc) GetProcAddress( m_hScannerDLL, "SI_Reset" )) == NULL)
	{	link = false;	}
	if ((SI_Diagnostic = (SI_DiagnosticProc) GetProcAddress( m_hScannerDLL, "SI_Diagnostic" )) == NULL)
	{	link = false;	}
	if ((SI_GetLastErrorText = (SI_GetLastErrorTextProc) GetProcAddress( m_hScannerDLL, "SI_GetLastErrorText" )) == NULL)
	{	link = false;	}
	if ((SI_GetLastError = (SI_GetLastErrorProc) GetProcAddress( m_hScannerDLL, "SI_GetLastError" )) == NULL)
	{	link = false;	}
	if ((SI_StartScan = (SI_StartScanProc) GetProcAddress( m_hScannerDLL, "SI_StartScan" )) == NULL)
	{	link = false;	}
	if ((SI_ReadImageData = (SI_ReadImageDataProc) GetProcAddress( m_hScannerDLL, "SI_ReadImageData" )) == NULL)
	{	link = false;	}
	if ((SI_EndScan = (SI_EndScanProc) GetProcAddress( m_hScannerDLL, "SI_EndScan" )) == NULL)
	{	link = false;	}
	if ((SI_OpenInterface = (SI_OpenInterfaceProc) GetProcAddress( m_hScannerDLL, "SI_OpenInterface" )) == NULL)
	{	link = false;	}
	if ((SI_CloseInterface = (SI_CloseInterfaceProc) GetProcAddress( m_hScannerDLL, "SI_CloseInterface" )) == NULL)
	{	link = false;	}
	if ((SI_GetEvent = (SI_GetEventProc) GetProcAddress( m_hScannerDLL, "SI_GetEvent" )) == NULL)
	{	link = false;	}
	if ((SI_Calibrate = (SI_CalibrateProc) GetProcAddress( m_hScannerDLL, "SI_Calibrate" )) == NULL)
	{	link = false;	}
	if ((SI_IsCalibrated = (SI_IsCalibratedProc) GetProcAddress( m_hScannerDLL, "SI_IsCalibrated" )) == NULL)
	{	link = false;	}
	if ((SI_Clean = (SI_CleanProc) GetProcAddress( m_hScannerDLL, "SI_Clean" )) == NULL)
	{	link = false;	}
	if ((SI_FeedPaperOut = (SI_FeedPaperOutProc) GetProcAddress( m_hScannerDLL, "SI_FeedPaperOut" )) == NULL)
	{	link = false;	}
	if ((SI_Feed = (SI_FeedProc) GetProcAddress( m_hScannerDLL, "SI_Feed" )) == NULL)
	{	link = false;	}

	if(link == false)
	{
		Detach();
		return false;
	}

	return true;
}


void Scanner::Detach()
{
	if(m_hScannerDLL)
	{
		FreeLibrary( m_hScannerDLL );
		m_hScannerDLL = NULL;
	}
}

